#include "CCTerm.h"

CCTerm::CCTerm(Symbol const* symbol, CCTerm** args,CCTerm* merge)
:Term(symbol,(Term**)args),
predList(merge == NULL ? new PredList() : NULL),
equivClass(merge == NULL ? this : merge->getEqClass()),
auxMember(-1)
#ifdef WEIGHTED_UNION
,weight(0) // is incremented to 1 later
#endif
{
#ifdef WEIGHTED_UNION
	equivClass->weight++;
#endif
}

CCTerm::CCTerm(Symbol const* symbol, CCTerm** args)
:Term(symbol,(Term**)args),
predList(new PredList()),
equivClass(this),
auxMember(-1)
#ifdef WEIGHTED_UNION
,weight(1)
#endif
{
}

CCTerm::~CCTerm()
{
	if(predList != NULL) {
		predList->clear();
		delete predList;
	}
}

Signature<EqClass>* CCTerm::getSignature() const {
	Signature<EqClass>* sig = new Signature<EqClass>(symbol);
	for(int i=0;i<symbol->getArity();i++) {
		(*sig)[i] = ((CCTerm*)args[i])->getEqClass();
	}
	return sig;
}
