#ifndef SIGTAB_H_
#define SIGTAB_H_

#include <ext/hash_map>

#include "hash_util.h"
#include "CCTerm.h"
#include "Equation.h"
#include "parsing.h"

typedef hash_map<string,Symbol const*> ArityTable;
typedef hash_map<Signature<EqClass>*,EqClass> SignatureTable;
typedef hash_map<Signature<int>*,int> IntSignatureTable;

/**
 * @autor Patrick Bahr
 */
class SigTab
{
public:
	SigTab(const SignatureTable& signatureTable);
	virtual ~SigTab();

	
	Equation<Term>* parseEquation(const string& equation);
	
	bool decide(Equation<Term>* equation);
	
private:
	int findEqClass(Term* t); 

	ArityTable arityTable;
	IntSignatureTable signatureTable;
	int nextClass;
};

#endif /*SIGTAB_H_*/
