#ifndef THEORYPARSEEXCEPTION_H_
#define THEORYPARSEEXCEPTION_H_

#include <string>

using namespace std;

#include "ParseException.h"

class TheoryParseException
{
public:
	TheoryParseException(const ParseException pe, string input, int line);
	virtual ~TheoryParseException();
	
	string getMessage() const;
	string getFullMessage() const;
	string getInput() const;
	int getLine();
	
	
private:
	const ParseException pe;
	const string input;
	const int line;
};

inline string TheoryParseException::getMessage() const {
	return pe.getMessage();
}
inline string TheoryParseException::getFullMessage() const {
	return pe.getFullMessage(input,line);
}
inline string TheoryParseException::getInput() const {
	return input;
}
inline int TheoryParseException::getLine() {
	return line;
}

#endif /*THEORYPARSEEXCEPTION_H_*/
